﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Runtime.Serialization.Formatters.Binary;

namespace WinGridButtonColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DataSource = GenerateDataSet();
            ultraGrid1.DisplayLayout.Override.SelectTypeCell = SelectType.ExtendedAutoDrag;
            ultraGrid1.DisplayLayout.Override.SelectTypeRow = SelectType.Default;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        public DataSet GenerateDataSet()
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("ID", typeof(int));
            table0.Columns.Add("Dosage", typeof(int));
            table0.Columns.Add("Drug", typeof(string));
            table0.Columns.Add("Patient", typeof(string));
            table0.Columns.Add("Date", typeof(DateTime));

            table0.Rows.Add(1, 25, "Indocin", "David", DateTime.Now);
            table0.Rows.Add(2, 50, "Enebrel", "Sam", DateTime.Now);
            table0.Rows.Add(3, 10, "Hydralazine", "Christoff", DateTime.Now);
            table0.Rows.Add(4, 21, "Combivent", "Janet", DateTime.Now);
            table0.Rows.Add(5, 100, "Dilantin", "Melanie", DateTime.Now);


            DataSet RetDataSet = new DataSet();
            RetDataSet.Tables.Add(table0);


            return RetDataSet;

        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

        }

        private void ultraGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == (Keys.Control | Keys.C))
            {
                Clipboard.Clear();
                UltraGridCell[] cells = new UltraGridCell[ultraGrid1.Selected.Cells.Count];
                ultraGrid1.Selected.Cells.CopyTo(cells, 0);
                Clipboard.SetData("SellCells", cells[0].Value.ToString());
            }

            if (e.KeyData == (Keys.Control | Keys.V))
            {

                string cell = (string)Clipboard.GetData("SellCells");
                UltraGridCell[] cells = new UltraGridCell[ultraGrid1.Selected.Cells.Count];
                ultraGrid1.Selected.Cells.CopyTo(cells, 0);
                int c = cells.GetLength(0);
                for (int i = 0; i < c; i++)
                {
                    try
                    {
                        ultraGrid1.DisplayLayout.Rows[cells[i].Row.Index].Cells[cells[i].Column.Key].Value =
                            cell;
                    }
                    catch
                    {
                    }
                }


            }

        }
    }
}
